(display "IN GOO!\n")

;;; from /usr/X11/include/X11/X.h

(define xt-no-event-mask 0)
(define xt-key-press-mask 1)
(define xt-key-release-mask 2)
(define xt-button-press-mask 4)
(define xt-button-release-mask 8)
(define xt-enter-window-mask 16)
(define xt-leave-window-mask 32)
(define xt-pointer-motion-mask 64)
(define xt-pointer-motion-hint-mask 128)
(define xt-button1-motion-mask 256)
(define xt-button2-motion-mask 512)
(define xt-button3-motion-mask 1024)
(define xt-button4-motion-mask 2048)
(define xt-button5-motion-mask 4096)
(define xt-button-motion-mask 8192)
(define xt-keymap-state-mask 16384)
(define xt-exposure-mask 32768)
(define xt-visibility-change-mask 65536)
(define xt-structure-notify-mask 131072)
(define xt-resize-redirect-mask 262144)
(define xt-substructure-notify-mask 524288)
(define xt-substructure-redirect-mask 262144)
(define xt-focus-change-mask 2097152)
(define xt-property-change-mask 4194304)
(define xt-colormap-change-mask 8388608)
(define xt-owner-grab-button-mask 16777216)

(define xt-key-press 2)
(define xt-key-release 3)
(define xt-button-press 4)
(define xt-button-release 5)
(define xt-motion-notify 6)
(define xt-enter-notify 7)
(define xt-leave-notify 8)
(define xt-focus-in 9)
(define xt-focus-out 10)
(define xt-keymap-notify 11)
(define xt-expose 12)
(define xt-graphics-expose 13)
(define xt-no-expose 14)
(define xt-visibility-notify 15)
(define xt-create-notify 16)
(define xt-destroy-notify 17)
(define xt-unmap-notify 18)
(define xt-map-notify 19)
(define xt-map-request 20)
(define xt-reparent-notify 21)
(define xt-configure-notify 22)
(define xt-configure-request 23)
(define xt-gravity-notify 24)
(define xt-resize-request 25)
(define xt-circulate-notify 26)
(define xt-circulate-request 27)
(define xt-property-notify 28)
(define xt-selection-clear 29)
(define xt-selection-request 30)
(define xt-selection-notify 31)
(define xt-colormap-notify 32)
(define xt-client-message 33)
(define xt-mapping-notify 34)




(define (form-menu menu-bar title items)
  (let* ((pulldown (xt-create-pulldown-menu menu-bar))
	 (cascade (xt-create-widget title
				    (xm-cascade-button-widget-class)
				    menu-bar
				    #f))
	 (title-str (xm-string-create-localized title)))
    (xt-set-value cascade (xm-n-sub-menu-id) pulldown)
    (xt-set-value cascade (xm-n-label-string) title-str)
    (xm-string-free title-str)
    (xt-manage-child cascade)
  
    (for-each (lambda (m)
		(let ((bp (xt-create-widget (car m)
					    (xm-push-button-widget-class)
					    pulldown
					    #f)))
		  (xt-manage-child bp)
		  (xt-add-callback bp (xm-n-activate-callback)
				   (cadr m) (cddr m))))
	      items)
    cascade))



;;; some callbacks

(define (blee widget client_data call_data)
  (display "BLEE: ")
  (display client_data)
  (display "\n"))


(define (menu-quit widget client_data call_data) (quit))


(define (draw-expose widget client_data call_data)
  (display "Drawing Area has been exposed\n"))


(define (draw-input widget client_data call_data)
  (let* ((event (xt-call-data-event call_data))
	 (event-elements (xt-unmangle-x-event event)))
    (if event-elements
	(cond ((eq? (car event-elements) xt-button-press)
	       (draw-button widget client_data call_data event-elements))
	      ((eq? (car event-elements) xt-key-press)
	       (draw-key widget client_data call_data event-elements))))))

  
(define (draw-button widget client_data call_data event-elements)
  (display "drawing area got button-press: ")
  (display (cadr event-elements))
  (display ", ")
  (display (caddr event-elements))
  (display "\n")

  (let* ((xdisplay (xt-display widget))
	 (drawable (xt-window widget))
	 (gc (xt-create-gc xdisplay drawable))
	 (x (cadr event-elements))
	 (y (caddr event-elements))
	 (width 30)
	 (height 20)
	 (font (xt-font-fid (xt-load-query-font xdisplay "12x24"))))
    (xt-set-font xdisplay gc font)
    (xt-draw-rectangle xdisplay drawable gc x y width height)
    (xt-draw-string xdisplay drawable gc x y "snider")
    (xt-free-gc xdisplay gc)))


(define (draw-key widget client_data call_data event-elements)
  (display "drawing area got key-press: ")
  (display (caddr event-elements))
  (display "(") (display (cadr event-elements)) (display ")")
  (display "\n"))
      

(define (draw-resize widget client_data call_data)
  (display "Drawing Area has been resized\n"))


(define (vsb-change widget client_data call_data)
  (display "vsb callback: ")
  (display client_data)
  (display ": ")
  (display (xt-get-value widget (xm-n-value)))
  (display "\n"))


(define (hsb-change widget client_data call_data)
  (display "hsb callback: ")
  (display client_data)
  (display ": ")
  (display (xt-get-value widget (xm-n-value)))
  (display "\n"))


;;; put together a window

(define top-level (xt-initialize "HI" "HO"))
(define app-context (xt-get-application-context top-level))
(define shell (xt-app-create-shell top-level "GOO"))
(define form (xt-create-widget "form" (xm-form-widget-class) shell #f))

;;; add some menus

(define menu-bar (xt-create-menu-bar form))
(xt-set-value menu-bar (xm-n-left-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-top-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-right-attachment) (xm-attach-form))
(xt-set-value menu-bar (xm-n-bottom-attachment) (xm-attach-none))
      
(define file-cascade
  (form-menu menu-bar "file" (list (list "open" blee "menu open")
				   (list "close" blee "menu close")
				   (list "save" blee "menu save")
				   (list "quit" menu-quit #f))))

(define edit-cascade
  (form-menu menu-bar "edit" (list (list "undo" blee "menu undo")
				   (list "cut" blee "menu cut")
				   (list "copy" blee "menu copy")
				   (list "paste" blee "menu paste"))))


;;; scroll bars

(define vsb (xt-create-widget "vsb" (xm-scroll-bar-widget-class) form #f))
(xt-set-value vsb (xm-n-orientation) (xm-vertical))
(xt-set-value vsb (xm-n-left-attachment) (xm-attach-none))

(xt-set-value vsb (xm-n-top-attachment) (xm-attach-widget))
(xt-set-value vsb (xm-n-top-widget) menu-bar)

(xt-set-value vsb (xm-n-right-attachment) (xm-attach-form))
(xt-set-value vsb (xm-n-bottom-attachment) (xm-attach-form))


(xt-add-callback vsb (xm-n-value-changed-callback) vsb-change '("value"))
(xt-add-callback vsb (xm-n-drag-callback) vsb-change '("drag"))
(xt-add-callback vsb (xm-n-increment-callback) vsb-change '("inc"))
(xt-add-callback vsb (xm-n-page-increment-callback) vsb-change '("page inc"))
(xt-add-callback vsb (xm-n-decrement-callback) vsb-change '("dec"))
(xt-add-callback vsb (xm-n-page-decrement-callback) vsb-change '("page dec"))


(define hsb
  (xt-create-widget "hsb" (xm-scroll-bar-widget-class) form 
		    (list (list (xm-n-orientation) (xm-horizontal))
			  (list (xm-n-left-attachment) (xm-attach-form))
			  (list (xm-n-top-attachment) (xm-attach-none))
			  (list (xm-n-right-attachment) (xm-attach-widget))
			  (list (xm-n-right-widget) vsb)
			  (list (xm-n-bottom-attachment) (xm-attach-form)))))


(xt-add-callback hsb (xm-n-value-changed-callback) hsb-change '("value"))
(xt-add-callback hsb (xm-n-drag-callback) hsb-change '("drag"))
(xt-add-callback hsb (xm-n-increment-callback) hsb-change '("inc"))
(xt-add-callback hsb (xm-n-page-increment-callback) hsb-change '("page inc"))
(xt-add-callback hsb (xm-n-decrement-callback) hsb-change '("dec"))
(xt-add-callback hsb (xm-n-page-decrement-callback) hsb-change '("page dec"))


;;; drawing area

(define draw (xt-create-widget "draw" (xm-drawing-area-widget-class) form #f))
(xt-set-value draw (xt-n-width) 432)
(xt-set-value draw (xt-n-height) 300)
(xt-set-value draw (xm-n-left-attachment) (xm-attach-form))

(xt-set-value draw (xm-n-top-attachment) (xm-attach-widget))
(xt-set-value draw (xm-n-top-widget) menu-bar)

(xt-set-value draw (xm-n-right-attachment) (xm-attach-widget))
(xt-set-value draw (xm-n-right-widget) vsb)
(xt-set-value draw (xm-n-bottom-attachment) (xm-attach-widget))
(xt-set-value draw (xm-n-bottom-widget) hsb)

(xt-add-callback draw (xm-n-expose-callback) draw-expose (list #f))
(xt-add-callback draw (xm-n-input-callback) draw-input (list #f))
(xt-add-callback draw (xm-n-resize-callback) draw-resize (list #f))

;;;

;;; work around a bug? in lesstif where
;   the cascade buttons get keypresses that
;   should have gone to the drawing area
(xt-set-keyboard-focus file-cascade draw)
(xt-set-keyboard-focus edit-cascade draw)

(xt-manage-child menu-bar)
(xt-manage-child draw)
(xt-manage-child vsb)
(xt-manage-child hsb)
(xt-manage-child form)
(xt-realize-widget shell)

(display "done with GOO\n")